<?php

namespace NoccyLabs\Plugin\Manager;


class PluginStream
{
    /** @var PluginManager */
    private static $manager;

    private $fd;

    public static function enable(PluginManager $manager)
    {
        if (!self::$manager) {
            stream_wrapper_register("plugin", static::class);
        }
        self::$manager = $manager;
    }

    public function stream_open($uri, $mode, $options, &$opened_path)
    {

        $pluginPath = substr($uri, strpos($uri, "://") + 3);
        $plugin = substr($pluginPath, 0, strpos($pluginPath, "/"));
        $path = substr($pluginPath, strpos($pluginPath, "/"));

        $manifest = self::$manager->findPlugin($plugin);

        $filepath = $manifest->translatePath($path);

        $this->fd = fopen($filepath, $mode);
        $opened_path = $filepath;

        return true;
    }

    public function stream_read($count)
    {
        return fread($this->fd, $count);
    }

    public function stream_write($data)
    {
        fwrite($this->fd, $data);
    }

    public function stream_tell()
    {
        return ftell($this->fd);
    }

    public function stream_stat()
    {
        return fstat($this->fd);
    }

    public function stream_eof()
    {
        return feof($this->fd);
    }



}